﻿namespace UltraChartPieChartOthers
{
    using System;
    using System.Collections.Generic;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {
        private List<KeyValuePair<int, string>> others = new List<KeyValuePair<int, string>>();

        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = this.GetData();
            this.ultraChart1.DataSource = ds;

            this.ultraChart1.PieChart3D.OthersCategoryPercent = 10;
        }

        private void UltraButtonOthers_Click(object sender, EventArgs e)
        {
            DataSet ds = (DataSet)this.ultraChart1.DataSource;
            DataTable dt = ds.Tables[0];
            List<KeyValuePair<int, string>> values = new List<KeyValuePair<int, string>>();

            int totalUnitsSold = 0;
            foreach (DataRow row in dt.Rows)
            {
                string product = row["Product"].ToString();
                int unitsSold = (int)row["Units Sold"];
                KeyValuePair<int, string> currentData = new KeyValuePair<int, string>(unitsSold, product);
                values.Add(currentData);
                totalUnitsSold += unitsSold;
            }

            foreach (KeyValuePair<int, string> value in values)
            {
                if (value.Key * 100 / totalUnitsSold < this.ultraChart1.PieChart3D.OthersCategoryPercent)
                {
                    others.Add(value);
                    Debug.WriteLine(string.Format("{0} - {1}", value.Value, value.Key));
                }
            }
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();

            DataTable dt = ds.Tables.Add("Data");
            dt.Columns.Add("Product", typeof(string));
            dt.Columns.Add("Units Sold", typeof(int));

            dt.Rows.Add(new object[] { "Java", 225 });
            dt.Rows.Add(new object[] { "ActiveX", 653 });
            dt.Rows.Add(new object[] { ".NET1", 335 });
            dt.Rows.Add(new object[] { "Misc", 132 });
            dt.Rows.Add(new object[] { "Native", 56 });
            dt.Rows.Add(new object[] { ".NET2", 62 });
            dt.Rows.Add(new object[] { "Apple", 42 });

            return ds;
        }
    }
}
